#include "precompile.h"

#include "jsondatamgr.h"
#include "app.h"

#include "framework/cpp/utils.h"

void JsonDataMgr::Init()
{
    if (!f8::IsOnlineEnv()) {
        if (f8::IsTestEnv()) {
            work_path_ = a8::Format("/root/pub/%d/%d/conf_test/game%d/textserver.test",
                                    {
                                     GAME_ID,
                                     App::Instance()->instance_id,
                                     GAME_ID
                                    });
        } else {
            work_path_ = a8::Format("/root/pub/%d/%d/conf_test/game%d/textserver.dev",
                                    {
                                     GAME_ID,
                                     App::Instance()->instance_id,
                                     GAME_ID
                                    });
        }
    }
    std::string textserver_cluster_json_file;
    textserver_cluster_json_file = a8::Format("%s/textserver.cluster.json",
                                              {
                                                  work_path_,
                                              });
    textserver_cluster_json_.ReadFromFile(textserver_cluster_json_file);
}

void JsonDataMgr::UnInit()
{
}

std::shared_ptr<a8::XObject> JsonDataMgr::GetConf()
{
    if (App::Instance()->instance_id < 1 || App::Instance()->instance_id > textserver_cluster_json_.Size()) {
        abort();
    }
    return textserver_cluster_json_[App::Instance()->instance_id - 1];
}
